unit FrmDirEntry;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActnList;

type
  TDirEntryForm = class(TForm)
    LName: TLabel;
    LPath: TLabel;
    LSize: TLabel;
    Ename: TEdit;
    EPath: TEdit;
    ESize: TEdit;
    EExtensions: TEdit;
    BOk: TButton;
    BCancel: TButton;
    LExtensions: TLabel;
    BSelectDir: TButton;
    ActionList1: TActionList;
    AOk: TAction;
    ACancel: TAction;
    procedure BSelectDirClick(Sender: TObject);
    procedure AOkUpdate(Sender: TObject);
    procedure ACancelExecute(Sender: TObject);
    procedure AOkExecute(Sender: TObject);
  private
    procedure SaveEntry;
    { Private declarations }
  public
    { Public declarations }

  end;

var
  DirEntryForm: TDirEntryForm;

implementation

uses filectrl,registry,cfgClean;

{$R *.dfm}

procedure TDirEntryForm.BSelectDirClick(Sender: TObject);

Var
  D : String;

begin
  D:=EPath.Text;
  If SelectDirectory(D,[],0) then
    EPath.Text:=D;
end;

procedure TDirEntryForm.AOkUpdate(Sender: TObject);
begin
  (Sender as Taction).Enabled:=(EName.Text<>'') and
                               (EPath.Text<>'');
end;

procedure TDirEntryForm.ACancelExecute(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TDirEntryForm.AOkExecute(Sender: TObject);

begin
  SaveEntry;
  ModalResult:=mrOk;
end;

procedure TDirEntryForm.SaveEntry;

begin
  With TRegistry.Create do
    Try
      If OpenKey(SKeyClean+SKeyDirs+'\'+EName.text,true) then
        begin
        WriteString(SKeyPath,EPath.Text);
        If ESize.Modified and (StrToIntDef(ESize.Text,-1)<>-1) then
          WriteInteger(SKeySize,StrToInt(ESize.Text));
        If (EExtensions.Modified) and (EExtensions.Text<>'') then
          WriteString(SKeyExtensions,EExtensions.Text);
        end;
    Finally
      Free;
    end;
end;

end.
