program diskclean;

uses
  SvcMgr,
  Forms,
  SysUtils,
  Windows,
  WinSvc,
  ServiceManager,
  svcClean in 'svcClean.pas' {CleanService: TService},
  thrClean in 'thrClean.pas',
  CfgClean in 'CfgClean.pas',
  frmManualclean in 'frmManualclean.pas' {ManualCleanForm};

{$R *.RES}

Var
  Installing : Boolean;

function IsInstalling: Boolean;
begin
  Result := FindCmdLineSwitch('INSTALL',['-','/'], True) or
            FindCmdLineSwitch('UNINSTALL',['-','/'], True);
end;

function StartService: Boolean;

Var
  Info : TServiceDescriptor;
  Buf : Array[0..255] of char;
  N : String;
  Size : DWord;
  F : TExt;

begin
  Result := False;
  Try
    With TServiceManager.Create(Nil) do
      try
        Connected:=True;
        QueryServiceConfig(SCleanService,Info);
        If CompareText(Info.UserName,'LocalSystem')=0 then
          Info.UserName:='System';
      finally
        Connected:=False;
        Free;
      end;
    Size:=256;
    GetUserName(@Buf[0],Size);
    N:=Buf;
    Result:=CompareText(N, Info.UserName)=0;
  Except
  end;
end;

begin
  Installing:=IsInstalling;
  if Installing or StartService then
    begin
    SvcMgr.Application.Initialize;
    SvcMgr.Application.Title := 'Disk cleaning service';
    svcMgr.Application.CreateForm(TCleanService, CleanService);
    svcMgr.Application.Run;
    end
  else
    begin
    Forms.Application.ShowMainForm := True;
    Forms.Application.Title:='Manual Disk cleaning service run';
    Forms.Application.Initialize;
    Forms.Application.CreateForm(TManualCleanForm, ManualCleanForm);
    Forms.Application.Run;
    end;
end.
